gLevelValues.exitCastleLevel = 32820
gLevelValues.exitCastleArea = 47384
gLevelValues.exitCastleWarpNode = 241

gBehaviorValues.KingBobombFVel = 3.0
gBehaviorValues.KingBobombYawVel = 256
gBehaviorValues.KingBobombHealth = 4

gBehaviorValues.KingWhompHealth = 3
gBehaviorValues.KoopaThiAgility = 6.0
gBehaviorValues.KoopaBobAgility = 4.0

gBehaviorValues.MipsStar1Requirement = 15
gBehaviorValues.MipsStar2Requirement = 50

gBehaviorValues.ToadStar1Requirement = 3
gBehaviorValues.ToadStar2Requirement = 25
gBehaviorValues.ToadStar3Requirement = 35

gLevelValues.pssSlideStarTime = 450

gLevelValues.metalCapDuration = 600
gLevelValues.wingCapDuration = 1800
gLevelValues.vanishCapDuration = 600

gLevelValues.metalCapDurationCotmc = 1
gLevelValues.wingCapDurationTotwc = 1
gLevelValues.vanishCapDurationVcutm = 1

gLevelValues.hudCapTimer = 1
gLevelValues.mushroom1UpHeal = 1
gLevelValues.wingCapLookUpReq = 13
gLevelValues.vanishCapSequence = 0x55

gBehaviorValues.starsNeededForDialog.dialog1 = 1
gBehaviorValues.starsNeededForDialog.dialog2 = 3
gBehaviorValues.starsNeededForDialog.dialog3 = 12
gBehaviorValues.starsNeededForDialog.dialog4 = 75
gBehaviorValues.starsNeededForDialog.dialog5 = 114
gBehaviorValues.starsNeededForDialog.dialog6 = 160

hook_event(HOOK_MARIO_UPDATE, function(m) m.numLives = 4 end)

--NoD Code
local once = true
hook_event(HOOK_MARIO_UPDATE,
function(m)
    if m.playerIndex ~= 0 then return end
    if once then
        m.numLives = 4
        once = true
    end
end)

---@param m MarioState
function WarpStars(m)

    if m.playerIndex ~= 0 then return end
    ---@type NetworkPlayer
    local np = gNetworkPlayers[0]

    gServerSettings.stayInLevelAfterStar = 1

    sLevelTable = {
        LEVEL_BOB,
        LEVEL_WF,
        LEVEL_JRB,
        LEVEL_CCM,
        LEVEL_BBH,
        LEVEL_HMC,
        LEVEL_LLL,
        LEVEL_SSL,
        LEVEL_DDD,
        LEVEL_SL,
        LEVEL_WDW,
        LEVEL_TTM,
        LEVEL_THI,
        LEVEL_TTC,
        LEVEL_BITFS,
        LEVEL_BITDW,
        LEVEL_BITS,
        LEVEL_CASTLE,
        LEVEL_CASTLE_COURTYARD,
        LEVEL_CASTLE_GROUNDS,
        LEVEL_PSS,
        LEVEL_SA,
        LEVEL_WMOTR,
        LEVEL_ENDING,
        LEVEL_BOWSER_1,
        LEVEL_BOWSER_2,
        LEVEL_BOWSER_3,
        LEVEL_TOTWC,
        LEVEL_COTMC,
        LEVEL_VCUTM,
    }

    if np and sLevelTable and np.currLevelNum and np.currAreaIndex == 3 then
        gServerSettings.stayInLevelAfterStar = 1
    end
            if np.currLevelNum == LEVEL_RR and np.currAreaIndex == 3 then
                gServerSettings.stayInLevelAfterStar = 0
            end
        end

hook_event(HOOK_MARIO_UPDATE, WarpStars)