----------------
-----Models-----
----------------

-- If any of these are needed in another file, like the exclamation box, just make models you need global

local E_MODEL_WINDMILL = smlua_model_util_get_id("windmill_geo")
local E_MODEL_WINDHOUSE = smlua_model_util_get_id("windhouse_geo")
local E_MODEL_CROSS = smlua_model_util_get_id("cross_geo")
local E_MODEL_CROSS2 = smlua_model_util_get_id("cross2_geo")
local E_MODEL_FLOTROCK = smlua_model_util_get_id("flotrock_geo")
local E_MODEL_YOSHGRAY = smlua_model_util_get_id("yoshgray_geo")
local E_MODEL_PLATMOVE = smlua_model_util_get_id("platmove_geo")
local E_MODEL_WINDC2 = smlua_model_util_get_id("windc2_geo")
local E_MODEL_OCTC4 = smlua_model_util_get_id("octc4_geo")
local E_MODEL_UPDOWNC4 = smlua_model_util_get_id("updownc4_geo")
local E_MODEL_SPIDERWEB = smlua_model_util_get_id("spiderweb_geo")
local E_MODEL_C5WAT = smlua_model_util_get_id("c5wat_geo")
local E_MODEL_C5JRB = smlua_model_util_get_id("c5jrb_geo")
local E_MODEL_C5HEXA = smlua_model_util_get_id("c5hexa_geo")
local E_MODEL_C7AXE = smlua_model_util_get_id("c7axe_geo")
local E_MODEL_C7BLOCK = smlua_model_util_get_id("c7block_geo")
local E_MODEL_C8BOAT = smlua_model_util_get_id("c8boat_geo")
local E_MODEL_C9CLOCK = smlua_model_util_get_id("c9clock_geo")
local E_MODEL_C9FLOWER = smlua_model_util_get_id("c9flower_geo")
local E_MODEL_C9MUSH = smlua_model_util_get_id("c9mush_geo")
local E_MODEL_C9ACT = smlua_model_util_get_id("c9act_geo")
local E_MODEL_C9ARR = smlua_model_util_get_id("c9arr_geo")
local E_MODEL_C9CEL = smlua_model_util_get_id("c9cel_geo")
local E_MODEL_C9TTC = smlua_model_util_get_id("c9ttc_geo")
local E_MODEL_C9CUBE = smlua_model_util_get_id("c9cube_geo")
local E_MODEL_C10OCT = smlua_model_util_get_id("c10oct_geo")
local E_MODEL_C11OCT = smlua_model_util_get_id("c11oct_geo")
local E_MODEL_C12CLOUD = smlua_model_util_get_id("c12cloud_geo")
local E_MODEL_C12SAND = smlua_model_util_get_id("c12sand_geo")
local E_MODEL_C12A3 = smlua_model_util_get_id("c12a3_geo")
local E_MODEL_C15ACT = smlua_model_util_get_id("c15act_geo")
local E_MODEL_C15QUAD = smlua_model_util_get_id("c15quad_geo")
local E_MODEL_C15FLOWER = smlua_model_util_get_id("flowercup_geo")
local E_MODEL_BULLETCAGE = smlua_model_util_get_id("bulletcage_geo")
local E_MODEL_C15TICK = smlua_model_util_get_id("c15tick_geo")
local E_MODEL_SANEN = smlua_model_util_get_id("sanen_geo")
local E_MODEL_B1CROSS = smlua_model_util_get_id("b1cross_geo")
local E_MODEL_B1XCROSS = smlua_model_util_get_id("b1xcross_geo")
local E_MODEL_B1YCLOUD = smlua_model_util_get_id("b1ycloud_geo")
local E_MODEL_B1FQUICK = smlua_model_util_get_id("b1fquick_geo")
local E_MODEL_B2FPLAT = smlua_model_util_get_id("b2fplat_geo")
local E_MODEL_B2FPLAT2 = smlua_model_util_get_id("b2fplat2_geo")
local E_MODEL_B2CROSS = smlua_model_util_get_id("b2cross_geo")
local E_MODEL_B2CROSS2 = smlua_model_util_get_id("b2cross2_geo")
local E_MODEL_B2CROSS3 = smlua_model_util_get_id("b2cross3_geo")
local E_MODEL_B2A2 = smlua_model_util_get_id("b2a2_geo")
local E_MODEL_B2A3 = smlua_model_util_get_id("b2a3_geo")
local E_MODEL_PSSO1 = smlua_model_util_get_id("psso1_geo")
local E_MODEL_PSSO2 = smlua_model_util_get_id("psso2_geo")
local E_MODEL_PSSO3 = smlua_model_util_get_id("psso3_geo")
local E_MODEL_PSSO4 = smlua_model_util_get_id("psso4_geo")
local E_MODEL_PSSOD = smlua_model_util_get_id("pssod_geo")
local E_MODEL_WCREQ = smlua_model_util_get_id("wcreq_geo")
local E_MODEL_SA3 = smlua_model_util_get_id("sa3_geo")
local E_MODEL_WCO1 = smlua_model_util_get_id("wco1_geo")
local E_MODEL_WCO2 = smlua_model_util_get_id("wco2_geo")
local E_MODEL_WCO3 = smlua_model_util_get_id("wco3_geo")

--------------------
-----Collisions-----
--------------------

COL_WINDMILL = smlua_collision_util_get("windmill_col_collision")
COL_WINDHOUSE = smlua_collision_util_get("windhouse_col_collision")
COL_CROSS = smlua_collision_util_get("cross_col_collision")
COL_CROSS2 = smlua_collision_util_get("cross2_col_collision")
COL_FLOTROCK = smlua_collision_util_get("flotrock_col_collision")
COL_YOSHGRAY = smlua_collision_util_get("yoshgray_col_collision")
COL_PIPE = smlua_collision_util_get("warp_pipe_seg3_collision_03009AC8")
COL_PLATMOVE = smlua_collision_util_get("platmove_col_collision")
COL_WINDC2 = smlua_collision_util_get("windc2_col_collision")
COL_OCTC4 = smlua_collision_util_get("octc4_col_collision")
COL_UPDOWNC4 = smlua_collision_util_get("updownc4_col_collision")
COL_SPIDERWEB = smlua_collision_util_get("spiderweb_col_collision")
COL_C5WAT = smlua_collision_util_get("c5wat_col_collision")
COL_C5JRB = smlua_collision_util_get("c5jrb_col_collision")
COL_C5HEXA = smlua_collision_util_get("c5hexa_col_collision")
COL_C7AXE = smlua_collision_util_get("c7axe_col_collision")
COL_C7BLOCK = smlua_collision_util_get("c7block_col_collision")
COL_C8BOAT = smlua_collision_util_get("c8boat_col_collision")
COL_C9CLOCK = smlua_collision_util_get("c9clock_col_collision")
COL_C9MUSH = smlua_collision_util_get("c9mush_col_collision")
COL_C9ACT = smlua_collision_util_get("c9act_col_collision")
COL_C9ARR = smlua_collision_util_get("c9arr_col_collision")
COL_C9CEL = smlua_collision_util_get("c9cel_col_collision")
COL_C9TTC = smlua_collision_util_get("c9ttc_col_collision")
COL_C9CUBE = smlua_collision_util_get("c9cube_col_collision")
COL_C9FLOWER = smlua_collision_util_get("c9flower_col_collision")
COL_C10OCT = smlua_collision_util_get("c10oct_col_collision")
COL_C11OCT = smlua_collision_util_get("c11oct_col_collision")
COL_C12CLOUD = smlua_collision_util_get("c12cloud_col_collision")
COL_C12SAND = smlua_collision_util_get("c12sand_col_collision")
COL_C12A3 = smlua_collision_util_get("c12a3_col_collision")
COL_C15ACT = smlua_collision_util_get("c15act_col_collision")
COL_C15QUAD = smlua_collision_util_get("c15quad_col_collision")
COL_C15FLOWER = smlua_collision_util_get("flowercup_col_collision")
COL_C15TICK = smlua_collision_util_get("c15tick_col_collision")
COL_SANEN = smlua_collision_util_get("sanen_col_collision")
COL_B1YCLOUD = smlua_collision_util_get("b1ycloud_col_collision")
COL_B1FQUICK = smlua_collision_util_get("b1fquick_col_collision")
COL_B2FPLAT = smlua_collision_util_get("b2fplat_col_collision")
COL_B2FPLAT2 = smlua_collision_util_get("b2fplat2_col_collision")
COL_B2CROSS = smlua_collision_util_get("b2cross_col_collision")
COL_B2CROSS2 = smlua_collision_util_get("b2cross2_col_collision")
COL_B2CROSS3 = smlua_collision_util_get("b2cross3_col_collision")
COL_B2A2 = smlua_collision_util_get("b2a2_col_collision")
COL_B2A3 = smlua_collision_util_get("b2a3_col_collision")
COL_PSSO1 = smlua_collision_util_get("psso1_col_collision")
COL_PSSO2 = smlua_collision_util_get("psso2_col_collision")
COL_PSSO3 = smlua_collision_util_get("psso3_col_collision")
COL_PSSOD = smlua_collision_util_get("pssod_col_collision")
COL_SA3 = smlua_collision_util_get("sa3_col_collision")
COL_WCO1 = smlua_collision_util_get("wco1_col_collision")
COL_WCO2 = smlua_collision_util_get("wco2_col_collision")
COL_WCO3 = smlua_collision_util_get("wco3_col_collision")

-------------------
-----Functions-----
-------------------

------ Windmill ------

---@param o Object
function windmill_init(o)
    obj_set_model_extended(o, E_MODEL_WINDMILL)
    o.collisionData = COL_WINDMILL
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function windmill_loop(o)

    o.oFaceAngleRoll = o.oFaceAngleRoll +69
    o.oAngleVelRoll = 69
    load_object_collision_model()
end

id_Bhv_Custom_Windmill = hook_behavior(nil, OBJ_LIST_SURFACE, false, windmill_init, windmill_loop, "Bhv_Custom_Windmill")

------ WindC2------

---@param o Object
function windc2_init(o)
    obj_set_model_extended(o, E_MODEL_WINDC2)
    o.collisionData = COL_WINDC2
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function windc2_loop(o)

    o.oFaceAngleRoll = o.oFaceAngleRoll -69
    o.oAngleVelRoll = -69
    load_object_collision_model()
end

id_bhvTowerPlatformGroup = hook_behavior(id_bhvTowerPlatformGroup, OBJ_LIST_SURFACE, true, windc2_init, windc2_loop, "bhvTowerPlatformGroup")

------ WindHouse ------

---@param o Object
function windhouse_init(o)
    obj_set_model_extended(o, E_MODEL_WINDHOUSE)
    o.collisionData = COL_WINDHOUSE
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
end

---@param o Object
function windhouse_loop(o)

    load_object_collision_model()
    o.oFaceAngleRoll = o.oFaceAngleRoll +69
    o.oAngleVelRoll = 69
end

id_Bhv_Custom_0x13002404 = hook_behavior(nil, OBJ_LIST_SURFACE, false, windhouse_init, windhouse_loop, "Bhv_Custom_0x13002404")

------ Cross ------

---@param o Object
function cross_init(o)
    obj_set_model_extended(o, E_MODEL_CROSS)
    o.collisionData = COL_CROSS
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function cross_loop(o)

    o.oFaceAngleYaw = o.oFaceAngleYaw +140
    o.oAngleVelYaw = 140
    load_object_collision_model()
end

id_Bhv_Custom_Cross = hook_behavior(nil, OBJ_LIST_SURFACE, false, cross_init, cross_loop, "Bhv_Custom_Cross")

------ Cross2 ------

---@param o Object
function cross2_init(o)
    obj_set_model_extended(o, E_MODEL_CROSS2)
    o.collisionData = COL_CROSS2
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function cross2_loop(o)

    o.oFaceAnglePitch = o.oFaceAnglePitch +500
    o.oAngleVelPitch = 500
    load_object_collision_model()
end

id_Bhv_Custom_Cross2 = hook_behavior(nil, OBJ_LIST_SURFACE, false, cross2_init, cross2_loop, "Bhv_Custom_Cross2")

------ FLOTROCK ------

---@param o Object
function flotrock_init(o)
    obj_set_model_extended(o, E_MODEL_FLOTROCK)
    o.collisionData = COL_FLOTROCK
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function flotrock_loop(o)

    bhv_floating_platform_loop()
    load_object_collision_model()
end

id_Bhv_Custom_0x13003948 = hook_behavior(nil, OBJ_LIST_SURFACE, false, flotrock_init, flotrock_loop, "Bhv_Custom_0x13003948")

------ YOSHGRAY ------

---@param o Object
function yoshgray_init(o)
    obj_set_model_extended(o, E_MODEL_YOSHGRAY)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oDistanceToMario = 32767
    o.oDrawingDistance = 32767
    network_init_object(o, true, nil)
end

---@param o Object
function yoshgray_loop(o)
    o.oPosZ = o.oPosZ -100
end

id_Bhv_Custom_0x13000184 = hook_behavior(nil, OBJ_LIST_SURFACE, false, yoshgray_init, yoshgray_loop, "Bhv_Custom_0x13000184")

------ CUSTOMPIPE ------

---@param o Object
function bhv_klepto_init(o)
    obj_set_model_extended(o, E_MODEL_BITS_WARP_PIPE)
    o.oFlags = OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PIPE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oInteractType = INTERACT_WARP
    o.oIntangibleTimer = 0
    o.hitboxHeight = 50
    o.hitboxRadius = 70
    network_init_object(o, true, nil)
end

function bhv_klepto_update(o)

    local m = gMarioStates[0]

    load_object_collision_model()
    bhv_warp_loop()
    local klepto = obj_get_first_with_behavior_id(id_bhvKlepto)
        if m.numStars < o.oBehParams2ndByte then
        obj_mark_for_deletion(klepto)
    end
  end

id_bhvKlepto = hook_behavior(id_bhvKlepto, OBJ_LIST_SURFACE, true, bhv_klepto_init, bhv_klepto_update, "bhvKlepto")

------ CUSTOMWC ------

---@param o Object
function bhv_wcreq_init(o)
    obj_set_model_extended(o, E_MODEL_WCREQ)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

function bhv_wcreq_loop(o)

    local m = gMarioStates[0]

    load_object_collision_model()
    local klepto = obj_get_first_with_behavior_id(id_bhvHiddenAt120Stars)
        if m.numStars < o.oBehParams2ndByte then
        obj_mark_for_deletion(klepto)
    end
  end

id_bhvHiddenAt120Stars = hook_behavior(id_bhvHiddenAt120Stars, OBJ_LIST_SURFACE, true, bhv_wcreq_init, bhv_wcreq_loop, "bhvHiddenAt120Stars")

------ PEAKPLATFORM ------

---@param o Object
function bhv_big_boulder_init(o)
    obj_set_model_extended(o, E_MODEL_PLATMOVE)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PLATMOVE
    o.oDistanceToMario = 32767
    o.oDrawingDistance = 32767
    o.oCollisionDistance = 32767
    o.oAction = 7
    obj_set_face_angle(o, o.oFaceAnglePitch, o.oFaceAngleYaw, o.oFaceAngleRoll)
    obj_set_move_angle(o, o.oMoveAnglePitch, o.oMoveAngleYaw, o.oMoveAngleRoll)
    network_init_object(o, false, nil)
end

---@param o Object
function bhv_big_boulder_loop(o)

    local m = gMarioStates[0]

    load_object_collision_model()
    if m.floor.object ~= nil then
    if m.floor.object.oAction == 7 and (m.pos.y == m.floorHeight) and
        o.oBehParams2ndByte == 0 then
    o.oPosX = o.oPosX -15
    o.oVelX = -15

    elseif
        m.floor.object.oAction == 7 and (m.pos.y == m.floorHeight) and
        o.oBehParams2ndByte == 1 then
    o.oPosZ = o.oPosZ -15
    o.oVelZ = -15

        end
    end
end

id_bhvBigBoulder = hook_behavior(id_bhvBigBoulder, OBJ_LIST_SURFACE, true, bhv_big_boulder_init, bhv_big_boulder_loop, "bhvBigBoulder")

------ OCTC4------

---@param o Object
function octc4_init(o)
    obj_set_model_extended(o, E_MODEL_OCTC4)
    o.collisionData = COL_OCTC4
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function octc4_loop(o)

    o.oFaceAngleYaw = o.oFaceAngleYaw -69
    o.oAngleVelYaw = -69
    load_object_collision_model()
end

id_bhvBitfsSinkingCagePlatform = hook_behavior(id_bhvBitfsSinkingCagePlatform, OBJ_LIST_SURFACE, true, octc4_init, octc4_loop, "bhvBitfsSinkingCagePlatform")

------ OCTC42 ------

---@param o Object
function octc42_init(o)
    obj_set_model_extended(o, E_MODEL_OCTC4)
    o.collisionData = COL_OCTC4
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function octc42_loop(o)

    o.oFaceAngleYaw = o.oFaceAngleYaw +69
    o.oAngleVelYaw = 69
    load_object_collision_model()
end

id_bhvBitfsSinkingPlatforms = hook_behavior(id_bhvBitfsSinkingPlatforms, OBJ_LIST_SURFACE, true, octc42_init, octc42_loop, "bhvBitfsSinkingPlatforms")

------ PEAKPLATFORM ------

---@param o Object
function bhv_updownc4_init(o)
    obj_set_model_extended(o, E_MODEL_UPDOWNC4)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_UPDOWNC4
    o.oDistanceToMario = 32767
    o.oDrawingDistance = 32767
    o.oCollisionDistance = 32767
    o.oAction = 8
    o.oHomeY = o.oPosY
    network_init_object(o, true, { 'oSinkWhenSteppedOnUnk104', 'oGraphYOffset', 'oHomeY' })
end

---@param o Object
function bhv_updownc4_loop(o)

    load_object_collision_model()
    sinking_perform_sink_check(o)
end

function find_y_offset_for_sinking_platform(obj, sinkOffset, a3)

    if not (cur_obj_is_any_player_on_platform() == 0) then
        if obj.oSinkWhenSteppedOnUnk104 < 0x4000 then
        obj.oSinkWhenSteppedOnUnk104 = obj.oSinkWhenSteppedOnUnk104 + sinkOffset
else
        obj.oSinkWhenSteppedOnUnk104 = 0x4000
    end
else
    if obj.oSinkWhenSteppedOnUnk104 > 0 then
        obj.oSinkWhenSteppedOnUnk104 = obj.oSinkWhenSteppedOnUnk104 - sinkOffset
else
        obj.oSinkWhenSteppedOnUnk104 = 0
        end
    end

local yOffset = sins(obj.oSinkWhenSteppedOnUnk104) * a3
return yOffset
end

-- Replacement for bhv_lll_sinking_rock_block_loop()
function sinking_perform_sink_check(obj)
local yOffset = find_y_offset_for_sinking_platform(obj, 524, -510)

obj.oGraphYOffset = 0
obj.oPosY = obj.oHomeY + yOffset
end

id_bhvOctagonalPlatformRotating = hook_behavior(id_bhvOctagonalPlatformRotating, OBJ_LIST_SURFACE, true, bhv_updownc4_init, bhv_updownc4_loop, "bhvOctagonalPlatformRotating")

------ SPIDERWEB ------

---@param o Object
function spiderweb_init(o)

    obj_set_model_extended(o, E_MODEL_SPIDERWEB)
    o.collisionData = COL_SPIDERWEB
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oAction = 11
    network_init_object(o, true, nil)
end

---@param o Object
function spiderweb_loop(o)

    load_object_collision_model()

end

local function spiderweb_jump()

    local m = gMarioStates[0]

if m.floor.object ~= nil then
    if m.floor.object.oAction == 11 and
    (m.pos.y == m.floorHeight) then
    if m.action == ACT_JUMP or
    m.action == ACT_DOUBLE_JUMP or
    m.action == ACT_TRIPLE_JUMP or
    m.action == ACT_SPECIAL_TRIPLE_JUMP or
    m.action == ACT_STEEP_JUMP or
    m.action == ACT_SIDE_FLIP or
    m.action == ACT_BACKFLIP or
    m.action == ACT_LONG_JUMP or
    m.action == ACT_RIDING_SHELL_JUMP then
    m.vel.y = m.vel.y +30
    spawn_mist_particles()
    m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
            end
        end
    end
end


hook_event(HOOK_BEFORE_PHYS_STEP, spiderweb_jump)

id_bhvDddMovingPole = hook_behavior(id_bhvDddMovingPole, OBJ_LIST_SURFACE, true, spiderweb_init, spiderweb_loop, "bhvDddMovingPole")

------ C5WAT ------

---@param o Object
function c5wat_init(o)
    obj_set_model_extended(o, E_MODEL_C5WAT)
    o.collisionData = COL_C5WAT
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c5wat_loop(o)

    bhv_floating_platform_loop()
    load_object_collision_model()
end

id_bhvSlidingPlatform2 = hook_behavior(id_bhvSlidingPlatform2, OBJ_LIST_SURFACE, true, c5wat_init, c5wat_loop, "bhvSlidingPlatform2")

------ C5JRB ------

---@param o Object
function seesaw_init(o)
    obj_set_model_extended(o, E_MODEL_C5JRB)
    o.collisionData = COL_C5JRB
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function seesaw_loop(o)

    bhv_seesaw_platform_update()
    load_object_collision_model()
end

id_Bhv_Custom_0x13004404 = hook_behavior(nil, OBJ_LIST_SURFACE, false, seesaw_init, seesaw_loop, "Bhv_Custom_0x13004404")

------ C5HEXA ------

---@param o Object
function c5hexa_init(o)
    obj_set_model_extended(o, E_MODEL_C5HEXA)
    o.collisionData = COL_C5HEXA
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c5hexa_loop(o)

    o.oFaceAngleYaw = o.oFaceAngleYaw +286
    o.oAngleVelYaw = 286
    load_object_collision_model()
end

id_bhvFerrisWheelAxle = hook_behavior(id_bhvFerrisWheelAxle, OBJ_LIST_SURFACE, true, c5hexa_init, c5hexa_loop, "bhvFerrisWheelAxle")

------ C5A2 ------

---@param o Object
function c5a2_init(o)
    obj_set_model_extended(o, E_MODEL_BOWSER_BOMB)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oIntangibleTimer = 0
    network_init_object(o, true, nil)
end

---@param o Object
function c5a2_loop(o)

    bhv_bowser_bomb_loop()
    obj_scale(o, 0.6)
    o.oPosZ = o.oPosZ +7
    load_object_collision_model()
end

id_bhvSquishablePlatform = hook_behavior(id_bhvSquishablePlatform, OBJ_LIST_GENACTOR, true, c5a2_init, c5a2_loop, "bhvSquishablePlatform")

------ C6A1 ------

---@param o Object
function c5a2_init(o)
    obj_set_model_extended(o, E_MODEL_BULLET_BILL)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_MOVE_XZ_USING_FVEL | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c5a2_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.4)
    bhv_bobomb_buddy_loop()
end

id_Bhv_Custom_0x13000618 = hook_behavior(nil, OBJ_LIST_GENACTOR, false, c5a2_init, c5a2_loop, "Bhv_Custom_0x13000618")

------ C7A1 ------

---@param o Object
function c7a1_init(o)
    obj_set_model_extended(o, E_MODEL_C7AXE)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C7AXE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c7a1_loop(o)

    load_object_collision_model()
    obj_scale(o, 1.85)
    o.oFaceAnglePitch = o.oFaceAnglePitch +282
    o.oAngleVelPitch = 282
end

id_bhvRrCruiserWing = hook_behavior(id_bhvRrCruiserWing, OBJ_LIST_SURFACE, true, c7a1_init, c7a1_loop, "bhvRrCruiserWing")

------ C7A2 ------

---@param o Object
function c7a2_init(o)
    obj_set_model_extended(o, E_MODEL_C7BLOCK)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C7BLOCK
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c7a2_loop(o)

    local m = gMarioStates[0]

    load_object_collision_model()
    if cur_obj_is_mario_ground_pounding_platform() == 1 then
        o.oPosY = o.oPosY -10
        play_sound(SOUND_GENERAL_POUND_ROCK, m.marioObj.header.gfx.cameraToObject)
end
end

id_Bhv_Custom_0x13003d38 = hook_behavior(nil, OBJ_LIST_SURFACE, false, c7a2_init, c7a2_loop, "Bhv_Custom_0x13003d38")

------ C8A1 ------

---@param o Object
function c8a1_init(o)
    obj_set_model_extended(o, E_MODEL_C8BOAT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C8BOAT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oHomeY = o.oPosY
    network_init_object(o, true, nil)
end

---@param o Object
function c8a1_loop(o)

    load_object_collision_model()
    bhv_lll_moving_octagonal_mesh_platform_loop()
end

id_bhvArrowLift = hook_behavior(id_bhvArrowLift, OBJ_LIST_SURFACE, true, c8a1_init, c8a1_loop, "bhvArrowLift")

------ C9A1 ------

---@param o Object
function c9a1_init(o)
    obj_set_model_extended(o, E_MODEL_C9CLOCK)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9CLOCK
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9a1_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.46)
    o.oFaceAngleRoll = o.oFaceAngleRoll +65023
    o.oAngleVelRoll = 65023
end

id_bhvDecorativePendulum = hook_behavior(id_bhvDecorativePendulum, OBJ_LIST_SURFACE, true, c9a1_init, c9a1_loop, "bhvDecorativePendulum")

------ C9A2 ------

---@param o Object
function c9a2_init(o)
    obj_set_model_extended(o, E_MODEL_C9FLOWER)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9FLOWER
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9a2_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +163
    o.oAngleVelYaw = 163
end

id_bhvLllRollingLog = hook_behavior(id_bhvLllRollingLog, OBJ_LIST_SURFACE, true, c9a2_init, c9a2_loop, "bhvLllRollingLog")

------ C9A3 ------

---@param o Object
function c9a3_init(o)
    obj_set_model_extended(o, E_MODEL_C9MUSH)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9MUSH
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oAction = 11
    network_init_object(o, true, nil)
end

---@param o Object
function c9a3_loop(o)

    load_object_collision_model()
end

id_bhvChainChompGate = hook_behavior(id_bhvChainChompGate, OBJ_LIST_SURFACE, true, c9a3_init, c9a3_loop, "bhvChainChompGate")

------ C9ACT ------

---@param o Object
function c9act_init(o)
    obj_set_model_extended(o, E_MODEL_C9ACT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9ACT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9act_loop(o)

    load_object_collision_model()
end

id_bhvControllablePlatformSub = hook_behavior(id_bhvControllablePlatformSub, OBJ_LIST_SURFACE, true, c9act_init, c9act_loop, "bhvControllablePlatformSub")

------ C9ARR ------

---@param o Object
function c9arr_init(o)
    obj_set_model_extended(o, E_MODEL_C9ARR)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9ARR
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9arr_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +157
    o.oAngleVelYaw = 157
end

id_Bhv_Custom_0x13001c84 = hook_behavior(nil, OBJ_LIST_SURFACE, false, c9arr_init, c9arr_loop, "Bhv_Custom_0x13001c84")

------ C9CEL ------

---@param o Object
function c9cel_init(o)
    obj_set_model_extended(o, E_MODEL_C9CEL)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9CEL
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9cel_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +175
    o.oAngleVelYaw = 175
end

id_bhvLllSinkingSquarePlatforms = hook_behavior(id_bhvLllSinkingSquarePlatforms, OBJ_LIST_SURFACE, true, c9cel_init, c9cel_loop, "bhvLllSinkingSquarePlatforms")

------ C9TTC ------

---@param o Object
function c9ttc_init(o)
    obj_set_model_extended(o, E_MODEL_C9TTC)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9TTC
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9ttc_loop(o)

    load_object_collision_model()
end

id_bhvTTCTreadmill = hook_behavior(id_bhvTTCTreadmill, OBJ_LIST_SURFACE, true, c9ttc_init, c9ttc_loop, "bhvTTCTreadmill")

------ C9CUBE ------

---@param o Object
function c9cube_init(o)
    obj_set_model_extended(o, E_MODEL_C9CUBE)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C9CUBE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c9cube_loop(o)

    load_object_collision_model()
    bhv_arrow_lift_loop()
end

id_bhvLllBowserPuzzlePiece = hook_behavior(id_bhvLllBowserPuzzlePiece, OBJ_LIST_SURFACE, true, c9cube_init, c9cube_loop, "bhvLllBowserPuzzlePiece")

------ C10OCT ------

---@param o Object
function c10oct_init(o)
    obj_set_model_extended(o, E_MODEL_C10OCT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C10OCT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c10oct_loop(o)

    load_object_collision_model()
    bhv_ssl_moving_pyramid_wall_loop()
end

id_bhvKoopaFlag = hook_behavior(id_bhvKoopaFlag, OBJ_LIST_SURFACE, true, c10oct_init, c10oct_loop, "bhvKoopaFlag")

------ C10OCT2 ------

---@param o Object
function c10oct2_init(o)
    obj_set_model_extended(o, E_MODEL_C10OCT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C10OCT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c10oct2_loop(o)

    load_object_collision_model()
end

id_bhvLllVolcanoFallingTrap = hook_behavior(id_bhvLllVolcanoFallingTrap, OBJ_LIST_SURFACE, true, c10oct2_init, c10oct2_loop, "bhvLllVolcanoFallingTrap")

------ C11OCT ------

---@param o Object
function c11oct_init(o)
    obj_set_model_extended(o, E_MODEL_C11OCT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C11OCT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c11oct_loop(o)

    load_object_collision_model()
    o.oFaceAnglePitch = o.oFaceAnglePitch + 65412
    o.oAngleVelPitch = 65412
end

id_bhvTTCSpinner = hook_behavior(id_bhvTTCSpinner, OBJ_LIST_SURFACE, true, c11oct_init, c11oct_loop, "bhvTTCSpinner")

------ C12CLOUD ------

---@param o Object
function c12cloud_init(o)
    obj_set_model_extended(o, E_MODEL_C12CLOUD)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C12CLOUD
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    o.oAction = 11
    network_init_object(o, true, nil)
end

---@param o Object
function c12cloud_loop(o)

    load_object_collision_model()
end

id_bhvMantaRay = hook_behavior(id_bhvMantaRay, OBJ_LIST_SURFACE, true, c12cloud_init, c12cloud_loop, "bhvMantaRay")

------ C12SAND ------

---@param o Object
function c12sand_init(o)
    obj_set_model_extended(o, E_MODEL_C12SAND)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C12SAND
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c12sand_loop(o)

    load_object_collision_model()
    o.oPosY = o.oPosY +5
end

id_bhvJetStreamRingSpawner = hook_behavior(id_bhvJetStreamRingSpawner, OBJ_LIST_SURFACE, true, c12sand_init, c12sand_loop, "bhvJetStreamRingSpawner")

------ SA3 ------

---@param o Object
function sa3_init(o)
    obj_set_model_extended(o, E_MODEL_SA3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_SA3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function sa3_loop(o)

    load_object_collision_model()
    if o.oTimer <= 2670 then
        o.oPosY = o.oPosY + 5
    elseif o.oTimer >= 2670 then
    o.oPosY = o.oPosY +0
end
end

id_bhvWfSlidingPlatform = hook_behavior(id_bhvWfSlidingPlatform, OBJ_LIST_SURFACE, true, sa3_init, sa3_loop, "bhvWfSlidingPlatform")

------ C12A3 ------

---@param o Object
function c12a3_init(o)
    obj_set_model_extended(o, E_MODEL_C12A3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C12A3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c12a3_loop(o)

    load_object_collision_model()
    bhv_floating_platform_loop()
end

id_Bhv_Custom_0x13003764 = hook_behavior(nil, OBJ_LIST_SURFACE, false, c12a3_init, c12a3_loop, "Bhv_Custom_0x13003764")

------ C15ACT ------

---@param o Object
function c15act_init(o)
    obj_set_model_extended(o, E_MODEL_C15ACT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C15ACT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c15act_loop(o)

    load_object_collision_model()
end

id_bhvBbhTiltingTrapPlatform = hook_behavior(id_bhvBbhTiltingTrapPlatform, OBJ_LIST_SURFACE, true, c15act_init, c15act_loop, "bhvBbhTiltingTrapPlatform")

------ C15QUAD ------

---@param o Object
function c15act_init(o)
    obj_set_model_extended(o, E_MODEL_C15QUAD)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C15QUAD
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c15act_loop(o)

    load_object_collision_model()
    bhv_squarish_path_moving_loop()
end

id_bhvHauntedBookshelfManager = hook_behavior(id_bhvHauntedBookshelfManager, OBJ_LIST_SURFACE, true, c15act_init, c15act_loop, "bhvHauntedBookshelfManager")

------ C15FLOWERCUP ------

---@param o Object
function c15flower_init(o)
    obj_set_model_extended(o, E_MODEL_C15FLOWER)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C15FLOWER
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c15flower_loop(o)

    load_object_collision_model()
end

id_Bhv_Custom_Flower = hook_behavior(nil, OBJ_LIST_SURFACE, true, c15flower_init, c15flower_loop, "Bhv_Custom_Flower")

------ BULLETCAGE ------

---@param o Object
function bulletcage_init(o)
    obj_set_model_extended(o, E_MODEL_BULLETCAGE)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_HOLDABLE | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function bulletcage_loop(o)

    bhv_bobomb_buddy_loop()
end

id_Bhv_Custom_Cage = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bulletcage_init, bulletcage_loop, "Bhv_Custom_Cage")

------ C15TICK ------

---@param o Object
function c15tick_init(o)
    obj_set_model_extended(o, E_MODEL_C15TICK)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C15TICK
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function c15tick_loop(o)

    load_object_collision_model()
end

id_bhvHauntedBookshelf = hook_behavior(id_bhvHauntedBookshelf, OBJ_LIST_SURFACE, true, c15tick_init, c15tick_loop, "bhvHauntedBookshelf")

------ SANEN ------

---@param o Object
function sanen_init(o)
    obj_set_model_extended(o, E_MODEL_SANEN)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_SANEN
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function sanen_loop(o)

    load_object_collision_model()
    bhv_floating_platform_loop()
end

id_Bhv_Custom_0x13003450 = hook_behavior(nil, OBJ_LIST_SURFACE, false, sanen_init, sanen_loop, "Bhv_Custom_0x13003450")

------ B1CROSS ------

---@param o Object
function b1cross_init(o)
    obj_set_model_extended(o, E_MODEL_B1CROSS)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b1cross_loop(o)
    
    obj_scale(o, 1.6)
    o.oFaceAngleYaw = o.oFaceAngleYaw +2560
end

id_Bhv_Custom_0x13003b88 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b1cross_init, b1cross_loop, "Bhv_Custom_0x13003b88")

------ B1CROSSSMALL ------

---@param o Object
function b1crosss_init(o)
    obj_set_model_extended(o, E_MODEL_B1CROSS)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b1crosss_loop(o)

    o.oFaceAngleYaw = o.oFaceAngleYaw +2560
end

id_Bhv_Custom_0x13003b74 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b1crosss_init, b1crosss_loop, "Bhv_Custom_0x13003b74")

------ B1XCROSS ------

---@param o Object
function b1xcross_init(o)
    obj_set_model_extended(o, E_MODEL_B1XCROSS)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b1xcross_loop(o)

    o.oFaceAnglePitch = o.oFaceAnglePitch +1280
end

id_bhvPyramidElevator = hook_behavior(id_bhvPyramidElevator, OBJ_LIST_SURFACE, true, b1xcross_init, b1xcross_loop, "bhvPyramidElevator")

------ B1YCLOUD ------

---@param o Object
function b1ycloud_init(o)
    obj_set_model_extended(o, E_MODEL_B1YCLOUD)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B1YCLOUD
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true

    network_init_object(o, true, nil)
end

---@param o Object
function b1ycloud_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +200
    o.oAngleVelYaw = 200
end

id_Bhv_Custom_0x13002e7c = hook_behavior(nil, OBJ_LIST_SURFACE, false, b1ycloud_init, b1ycloud_loop, "Bhv_Custom_0x13002e7c")

------ PEAKPLATFORM ------

---@param o Object
function bhv_b1elev_init(o)
    obj_set_model_extended(o, E_MODEL_C12CLOUD)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_C12CLOUD
    o.oDistanceToMario = 32767
    o.oDrawingDistance = 32767
    o.oCollisionDistance = 32767
    o.oHomeY = o.oPosY
    network_init_object(o, true, { 'oSinkWhenSteppedOnUnk104', 'oGraphYOffset', 'oHomeY' })
end

---@param o Object
function bhv_b1elev_loop(o)

    load_object_collision_model()
    sinking_perform_unsink_check(o)
end

function find_y2_offset_for_sinking_platform(obj, sinkOffset, a23)

    if not (cur_obj_is_any_player_on_platform() == 0) then
        if obj.oSinkWhenSteppedOnUnk104 < 0x4000 then
        obj.oSinkWhenSteppedOnUnk104 = obj.oSinkWhenSteppedOnUnk104 - sinkOffset
else
        obj.oSinkWhenSteppedOnUnk104 = 0x4000
    end
else
    if obj.oSinkWhenSteppedOnUnk104 > 0 then
        obj.oSinkWhenSteppedOnUnk104 = obj.oSinkWhenSteppedOnUnk104 + sinkOffset
else
        obj.oSinkWhenSteppedOnUnk104 = 0
        end
    end

local y2Offset = sins(obj.oSinkWhenSteppedOnUnk104) * a23
return y2Offset
end

-- Replacement for bhv_lll_sinking_rock_block_loop()
function sinking_perform_unsink_check(obj)
local y2Offset = find_y2_offset_for_sinking_platform(obj, -250, -1000)

obj.oGraphYOffset = 0
obj.oPosY = obj.oHomeY - y2Offset
end

id_bhvCastleFloorTrap = hook_behavior(id_bhvCastleFloorTrap, OBJ_LIST_SURFACE, true, bhv_b1elev_init, bhv_b1elev_loop, "bhvCastleFloorTrap")

------ B1FQUICK ------

---@param o Object
function b1fquick_init(o)
    obj_set_model_extended(o, E_MODEL_B1FQUICK)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B1FQUICK
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b1fquick_loop(o)

    load_object_collision_model()
    o.oPosY = o.oPosY +8
end

id_bhvMoatGrills = hook_behavior(id_bhvMoatGrills, OBJ_LIST_SURFACE, true, b1fquick_init, b1fquick_loop, "bhvMoatGrills")

------ KEY ------

-- Thanks Blocky and SonicDark!

sCustomSecretHitbox = {
    interactType      = INTERACT_STAR_OR_KEY,
    downOffset        = 0,
    damageOrCoinValue = 0,
    health            = 0,
    numLootCoins      = 0,
    radius            = 120,
    height            = 50,
    hurtboxRadius     = 0,
    hurtboxHeight     = 0,
}

--- @param obj Object
function obj_set_hitbox(obj, hitbox)
    if obj == nil or hitbox == nil then return end
    if (obj.oFlags & OBJ_FLAG_30) == 0 then
        obj.oFlags = obj.oFlags | OBJ_FLAG_30

        obj.oInteractType = hitbox.interactType
        obj.oDamageOrCoinValue = hitbox.damageOrCoinValue
        obj.oHealth = hitbox.health
        obj.oNumLootCoins = hitbox.numLootCoins

        cur_obj_become_tangible()
    end

    obj.hitboxRadius = obj.header.gfx.scale.x * hitbox.radius
    obj.hitboxHeight = obj.header.gfx.scale.y * hitbox.height
    obj.hurtboxRadius = obj.header.gfx.scale.x * hitbox.hurtboxRadius
    obj.hurtboxHeight = obj.header.gfx.scale.y * hitbox.hurtboxHeight
    obj.hitboxDownOffset = obj.header.gfx.scale.y * hitbox.downOffset
end

---@param o Object
function b1fquick_init(o)
    obj_set_model_extended(o, E_MODEL_BOWSER_KEY)
    obj_set_hitbox(o, sCustomSecretHitbox)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b1fquick_loop(o)

    load_object_collision_model()
    bhv_collect_star_loop()
end

id_bhvFallingBowserPlatform = hook_behavior(id_bhvFallingBowserPlatform, OBJ_LIST_LEVEL, true, b1fquick_init, b1fquick_loop, "bhvFallingBowserPlatform")

------ B2FPLAT ------

sCustomHitbox = {
    interactType      = INTERACT_COIN,
    downOffset        = 0,
    damageOrCoinValue = 0,
    health            = 0,
    numLootCoins      = 0,
    radius            = 800,
    height            = 242,
    hurtboxRadius     = 0,
    hurtboxHeight     = 0,
}

--- @param obj Object
function obj_set_hitbox_2(obj, hitbox)
    if obj == nil or hitbox == nil then return end
    if (obj.oFlags & OBJ_FLAG_30) == 0 then
        obj.oFlags = obj.oFlags | OBJ_FLAG_30

        obj.oInteractType = hitbox.interactType
        obj.oDamageOrCoinValue = hitbox.damageOrCoinValue
        obj.oHealth = hitbox.health
        obj.oNumLootCoins = hitbox.numLootCoins

        cur_obj_become_tangible()
    end

    obj.hitboxRadius = obj.header.gfx.scale.x * hitbox.radius
    obj.hitboxHeight = obj.header.gfx.scale.y * hitbox.height
    obj.hurtboxRadius = obj.header.gfx.scale.x * hitbox.hurtboxRadius
    obj.hurtboxHeight = obj.header.gfx.scale.y * hitbox.hurtboxHeight
    obj.hitboxDownOffset = obj.header.gfx.scale.y * hitbox.downOffset
end

function bhv_trigger1_init(o)
    obj_set_hitbox_2(o, sCustomHitbox)
    obj_set_model_extended(o, E_MODEL_NONE)
    end

function bhv_trigger1_loop(o)
    if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(o)
        o.oInteractStatus = 0
    end
end

id_bhvTrigger = hook_behavior(nil, OBJ_LIST_LEVEL, false, bhv_trigger1_init, bhv_trigger1_loop, "bhvTrigger")

function bhv_trigger2_loop(o)
    if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(o)
        o.oInteractStatus = 0
    end
end

id_bhvTrigger2 = hook_behavior(nil, OBJ_LIST_LEVEL, false, bhv_trigger1_init, bhv_trigger2_loop, "bhvTrigger2")

function bhv_trigger3_loop(o)
    if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(o)
        o.oInteractStatus = 0
    end
end

id_bhvTrigger3 = hook_behavior(nil, OBJ_LIST_LEVEL, false, bhv_trigger1_init, bhv_trigger3_loop, "bhvTrigger3")

function bhv_trigger3_loop(o)
    if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(o)
        o.oInteractStatus = 0
    end
end

id_bhvTrigger4 = hook_behavior(nil, OBJ_LIST_LEVEL, false, bhv_trigger1_init, bhv_trigger3_loop, "bhvTrigger4")

---@param o Object
function b2fplat_init(o)
    obj_set_model_extended(o, E_MODEL_B2FPLAT)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2FPLAT
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2fplat_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.62)
    if  obj_count_objects_with_behavior_id(id_bhvTrigger) <= 0 then
        o.oPosX = o.oPosX +18
        o.oVelX = 18
end
end

id_bhvHoot = hook_behavior(id_bhvHoot, OBJ_LIST_SURFACE, true, b2fplat_init, b2fplat_loop, "bhvHoot")

---@param o Object
function b2fplat2_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.62)
    if  obj_count_objects_with_behavior_id(id_bhvTrigger2) <= 0 then
        o.oPosX = o.oPosX +18
        o.oVelX = 18
end
end

id_bhvHoot2 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b2fplat_init, b2fplat2_loop, "bhvHoot2")

---@param o Object
function b2fplat3_init(o)
    obj_set_model_extended(o, E_MODEL_B2FPLAT2)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2FPLAT2
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2fplat3_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.62)
    if  obj_count_objects_with_behavior_id(id_bhvTrigger3) <= 0 then
        o.oPosX = o.oPosX +28
        o.oVelX = 28
end
end

id_bhvHoot3 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b2fplat3_init, b2fplat3_loop, "bhvHoot3")

---@param o Object
function b2fplat4_loop(o)

    load_object_collision_model()
    obj_scale(o, 0.62)
    if  obj_count_objects_with_behavior_id(id_bhvTrigger4) <= 0 then
        o.oPosX = o.oPosX +28
        o.oVelX = 28
end
end

id_bhvHoot4 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b2fplat3_init, b2fplat4_loop, "bhvHoot4")

------ B2CROSS ------

---@param o Object
function b2cross_init(o)
    obj_set_model_extended(o, E_MODEL_B2CROSS)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2CROSS
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2cross_loop(o)

    load_object_collision_model()
    o.oFaceAnglePitch = o.oFaceAnglePitch +416
    o.oAngleVelPitch = 416
    end

id_bhvJrbSlidingBox = hook_behavior(id_bhvJrbSlidingBox, OBJ_LIST_SURFACE, true, b2cross_init, b2cross_loop, "bhvJrbSlidingBox")


------ B2CROSS2 ------

---@param o Object
function b2cross2_init(o)
    obj_set_model_extended(o, E_MODEL_B2CROSS2)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2CROSS2
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2cross2_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +256
    o.oAngleVelYaw = 256
    end

id_bhvBooInCastle = hook_behavior(id_bhvBooInCastle, OBJ_LIST_SURFACE, true, b2cross2_init, b2cross2_loop, "bhvBooInCastle")

------ B2CROSS3 ------

---@param o Object
function b2cross3_init(o)
    obj_set_model_extended(o, E_MODEL_B2CROSS3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2CROSS3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2cross3_loop(o)

    load_object_collision_model()
    obj_scale(o, 1.6)
    o.oFaceAngleYaw = o.oFaceAngleYaw +137
    o.oAngleVelYaw = 137
    end

id_bhvMeshElevator = hook_behavior(id_bhvMeshElevator, OBJ_LIST_SURFACE, true, b2cross3_init, b2cross3_loop, "bhvMeshElevator")

------ B2A2 ------

---@param o Object
function b2a2_init(o)
    obj_set_model_extended(o, E_MODEL_B2A2)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2A2
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2a2_loop(o)

    load_object_collision_model()
    if o.oInteractStatus & INT_STATUS_INTERACTED ~= 0 then
        o.oInteractStatus = 0
    end

    local parent = obj_get_first_with_behavior_id(id_bhvCustomSwitch)
    if parent then
        o.parentObj = parent
    else
        return
    end

    if parent.oAction == PURPLE_SWITCH_PRESSED then
                o.oPosY = o.oPosY -190
    end
end

id_Bhv_Custom_0x13002960 = hook_behavior(nil, OBJ_LIST_SURFACE, false, b2a2_init, b2a2_loop, "Bhv_Custom_0x13002960")

------ B2A3 ------

---@param o Object
function b2a3_init(o)
    obj_set_model_extended(o, E_MODEL_B2A3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_B2A3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function b2a3_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +200
    o.oAngleVelYaw = 200
    end

id_bhvBetaBowserAnchor = hook_behavior(id_bhvBetaBowserAnchor, OBJ_LIST_SURFACE, true, b2a3_init, b2a3_loop, "bhvBetaBowserAnchor")

------ PSSO1 ------

---@param o Object
function psso1_init(o)
    obj_set_model_extended(o, E_MODEL_PSSO1)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PSSO1
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function psso1_loop(o)

    load_object_collision_model()
    bhv_tumbling_bridge_platform_loop()
    end

id_Bhv_Custom_0x13002304 = hook_behavior(nil, OBJ_LIST_SURFACE, true, psso1_init, psso1_loop, "Bhv_Custom_0x13002304")

------ PSSO2 ------

---@param o Object
function psso2_init(o)
    obj_set_model_extended(o, E_MODEL_PSSO2)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PSSO2
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function psso2_loop(o)

    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +800
    o.oAngleVelYaw = 800
    end

id_Bhv_Custom_0x13002484 = hook_behavior(nil, OBJ_LIST_SURFACE, true, psso2_init, psso2_loop, "Bhv_Custom_0x13002484")

------ PSSO3 ------

---@param o Object
function psso3_init(o)
    obj_set_model_extended(o, E_MODEL_PSSO3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PSSO3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function psso3_loop(o)

    load_object_collision_model()
    bhv_ssl_moving_pyramid_wall_loop()
    end

id_bhvHiddenStaircaseStep = hook_behavior(id_bhvHiddenStaircaseStep, OBJ_LIST_SURFACE, true, psso3_init, psso3_loop, "bhvHiddenStaircaseStep")

------ PSSO4 ------

---@param o Object
function psso4_init(o)
    obj_set_model_extended(o, E_MODEL_PSSO4)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function psso4_loop(o)
    if o.oTimer <= 30 then
        cur_obj_enable_rendering()
    elseif o.oTimer >= 30 and o.oTimer <= 60 then
        cur_obj_disable_rendering()

        if o.oTimer >= 60 then
            o.oTimer = 0
        end
    end
end

id_bhvSunkenShipPart2 = hook_behavior(id_bhvSunkenShipPart2, OBJ_LIST_SURFACE, true, psso4_init, psso4_loop, "bhvSunkenShipPart2")

------ PSSOD ------

---@param o Object
function pssod_init(o)
    obj_set_model_extended(o, E_MODEL_PSSOD)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_PSSOD
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function pssod_loop(o)

    if o.oTimer <= 30 then
        cur_obj_enable_rendering()
        load_object_collision_model()
    elseif o.oTimer >= 30 and o.oTimer <= 60 then
        cur_obj_disable_rendering()

        if o.oTimer >= 60 then
            o.oTimer = 0
        end
    end
end

id_bhvDeathPlane = hook_behavior(nil, OBJ_LIST_SURFACE, true, pssod_init, pssod_loop, "bhvDeathPlane")

------ WCO1 ------

---@param o Object
function wco1_init(o)
    obj_set_model_extended(o, E_MODEL_WCO1)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_WCO1
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function wco1_loop(o)
    load_object_collision_model()
    o.oFaceAngleYaw = o.oFaceAngleYaw +3328
    o.oAngleVelYaw = 3328
end

id_bhvBetaTrampolineSpring = hook_behavior(id_bhvBetaTrampolineSpring, OBJ_LIST_SURFACE, true, wco1_init, wco1_loop, "bhvBetaTrampolineSpring")

------ WCO2 ------

---@param o Object
function wco2_init(o)
    obj_set_model_extended(o, E_MODEL_WCO2)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_WCO2
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function wco2_loop(o)
    load_object_collision_model()
    bhv_floating_platform_loop()
end

id_bhvBooCage = hook_behavior(id_bhvBooCage, OBJ_LIST_SURFACE, true, wco2_init, wco2_loop, "bhvBooCage")

------ WCO3 ------

---@param o Object
function wco3_init(o)
    obj_set_model_extended(o, E_MODEL_WCO3)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_WCO3
    o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
    network_init_object(o, true, nil)
end

---@param o Object
function wco3_loop(o)
    load_object_collision_model()
    bhv_lll_moving_octagonal_mesh_platform_loop()
end

id_bhvBetaTrampolineTop = hook_behavior(id_bhvBetaTrampolineTop, OBJ_LIST_SURFACE, true, wco3_init, wco3_loop, "bhvBetaTrampolineTop")